﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private ImageView1 As ImageView
	Private Button1 As Button
	
	Private mBcLine As BitmapCreator
	Private mLineWidth As Int
	Private mLineHeigth As Int	
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	#if B4j
		ImageView1.SetLayoutAnimated(0,0,ImageView1.Top,Root.Width,Root.Height-ImageView1.Top)
	#else if B4i
		ImageView1.SetLayoutAnimated(0,0,0,ImageView1.Top,Root.Width,Root.Height-ImageView1.Top)
	#end if
	
	mBcLine = BitmapToBC(xui.LoadBitmap(File.DirAssets,"Line5.png"), 1)
	
	mLineWidth=mBcLine.mWidth
	mLineHeigth=mBcLine.mHeight
	#if B4i
	ImageView1.Color=xui.Color_Green
	#else if b4j
	Root.Color=xui.Color_Green
	#End If
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	'xui.MsgboxAsync("Hello world!", "B4X")
	Dim Task As DrawTask
	Task=getDrawTask(xui.Color_RGB(255,127,39),mLineWidth*1.5,mLineHeigth*1.5)
	Dim bc As BitmapCreator
	Dim w As Int=ImageView1.Width
	Dim h As Int=ImageView1.Height
	Dim l As Int=Task.SrcRect.Right
	Dim x As Int,y As Int
	bc.Initialize(w,h)
	For i=1 To 100
		x=Rnd(0,w)
		y=Rnd(0,h)
		Task.TargetX=x
		Task.TargetY=y
		Task.Degrees=Rnd(0,360)
		Task.SrcRect.Right=Rnd(mLineWidth,l)
		bc.DrawBitmapCreatorTransformed(Task)
	Next
	bc.SetBitmapToImageView(bc.Bitmap,ImageView1)
End Sub

Private Sub getDrawTask(mColor As Int,w As Int,h As Int) As DrawTask
	Dim bc2 As BitmapCreator
	bc2=GreyscaleToColor(mBcLine,mColor)
	Dim mBmp As B4XBitmap =bc2.Bitmap
	
	bc2.Initialize(w*20,h)
	bc2.DrawRect2(bc2.TargetRect,bc2.CreateBrushFromBitmap(mBmp.Resize(w,h,True)),True,h)
	
	Dim bc3 As BitmapCreator
	bc3.Initialize(w*20,h)
	bc3.DrawBitmap(bc2.Bitmap,bc2.TargetRect,True)
	
	Return bc3.CreateDrawTask(bc3,bc3.TargetRect,0,0,True)
End Sub

Private Sub CopyBC(bc As BitmapCreator,SkipBlending As Boolean) As BitmapCreator
	Dim b2 As BitmapCreator
	b2.Initialize(bc.mWidth, bc.mHeight)
	b2.DrawBitmapCreator(bc, bc.TargetRect, 0, 0,  SkipBlending)
	Return b2
End Sub

Private Sub BitmapToBC(bmp As B4XBitmap, Scale As Float) As BitmapCreator
	Dim b2 As BitmapCreator
	b2.Initialize(bmp.Width / Scale, bmp.Height / Scale)
	b2.CopyPixelsFromBitmap(bmp)
	Return b2
End Sub

Private Sub GreyscaleToColor (src As BitmapCreator, TargetColor As Int) As BitmapCreator
	Dim bc As BitmapCreator = CopyBC(src,True)
	Dim a As ARGBColor
	Dim clr As ARGBColor
	Dim t As PremultipliedColor
	
	src.ColorToARGB(TargetColor, clr)
	For y = 0 To src.mHeight - 1
		For x = 0 To src.mWidth - 1
			src.GetARGB(x, y, a)
			If a.r<>255 And a.g<>255 And a.b<>255 Then
				Dim f As Float = a.r / 255
				a.r = clr.r * f
				a.g = clr.g * f
				a.b = clr.b * f
				If a.r>226 Then
					a.a=300-a.r
				End If
				bc.SetARGB(x, y, a)
			Else
				bc.SetPremultipliedColor(x,y,t)
			End If
		Next
	Next
	Return bc
End Sub
